# Class HealthAnchor

java.lang.Object
com.codename1.health.HealthAnchor

public final class HealthAnchor extends Object

An opaque cursor marking how far through a data type's change history the app has read. Wraps HealthKit's `HKQueryAnchor` and Health Connect's changes token.

You normally never touch this: `HealthStore` persists the anchor for each subscription itself, which is what lets a subscription survive the app being killed. It is exposed only so that an app syncing to its own server can checkpoint the cursor alongside its upload watermark and keep the two consistent.

Anchors expire. Health Connect change tokens are invalid after 30 days, and an iOS anchor can be rejected after a restore from backup. When that happens the next batch reports `HealthChangeBatch.isResyncRequired()` and the app must fall back to a full time-range read.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `static HealthAnchor`
  `fromStorableString(String stored)`
  Restores an anchor previously written out with `toStorableString()`.
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `static HealthAnchor`
  `of(String token)`
  Wraps a platform cursor.
  `String`
  `toStorableString()`
  A form of this anchor safe to persist in `Storage`, `Preferences` or your own database, and to pass back to `fromStorableString(String)` on a later launch.
  `String`
  `toString()`
  Returns a string representation of the object.

  ### Methods inherited from class Object

  `clone, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### of

    public static HealthAnchor of(String token)
    Wraps a platform cursor. Called by ports.

  - ### fromStorableString

    public static HealthAnchor fromStorableString(String stored)
    Restores an anchor previously written out with `toStorableString()`. Returns null for null or empty input, which callers should treat as "start from the beginning".

  - ### toStorableString

    public String toStorableString()

    A form of this anchor safe to persist in `Storage`, `Preferences` or your own database, and to pass back to `fromStorableString(String)` on a later launch.

    The contents are platform-specific and must not be parsed, compared for ordering, or sent to a different device.

  - ### equals

    public boolean equals(Object o)
    Description copied from class: `Object`
    Indicates whether some other object is "equal to" this one. The equals method implements an equivalence relation: It is reflexive: for any reference value x, x.equals(x) should return true. It is symmetric: for any reference values x and y, x.equals(y) should return true if and only if y.equals(x) returns true. It is transitive: for any reference values x, y, and z, if x.equals(y) returns true and y.equals(z) returns true, then x.equals(z) should return true. It is consistent: for any reference values x and y, multiple invocations of x.equals(y) consistently return true or consistently return false, provided no information used in equals comparisons on the object is modified. For any non-null reference value x, x.equals(null) should return false. The equals method for class Object implements the most discriminating possible equivalence relation on objects; that is, for any reference values x and y, this method returns true if and only if x and y refer to the same object (x==y has the value true).
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Description copied from class: `Object`
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`

  - ### toString

    public String toString()
    Description copied from class: `Object`
    Returns a string representation of the object. In general, the toString method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method. The toString method for class Object returns a string consisting of the name of the class of which the object is an instance, the at-sign character `@', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of: getClass().getName() + '@' + Integer.toHexString(hashCode())
    Overrides:
      `toString` in class `Object`